import win32.windows;
import win32.windef;
import win32.commctrl;
import win32frame.DialogBoxClass;
import win32frame.CheckBox;
import win32frame.PushButton;
import win32frame.TextBox;
import std.stdio;
import std.string;
import std.utf;

import Spin ;

ushort LOWORD(uint l){ return l & 0xffff; }

enum CMD{
  OK     = 0x100, 
  CANCEL = 0x101,
} ;

class NewCanvasDialog : DialogBoxClass {
  Spin          spinWidth  ;
  Spin          spinHeight ;
  
  PushButton    buttonOK  ;
  PushButton    buttonCAN ;
  HFONT         hfont;

  int           width  ;
  int           height ;

  int           state ;

  this(string name, string ClassName) {
    UnregisterClass( cast(wchar*)(ClassName), GetModuleHandle(null) ) ;
    winc.cbSize         = WNDCLASSEX.sizeof;
    winc.style          = 0; //CS_HREDRAW | CS_VREDRAW ;
    winc.cbClsExtra     = 0;
    winc.cbWndExtra     = 0;
    winc.hIcon          = LoadIcon(null , cast(wchar*)(IDI_APPLICATION));
    winc.hCursor        = LoadCursor(null , cast(wchar*)(IDC_ARROW));
    winc.hbrBackground  = CreateSolidBrush(GetSysColor(COLOR_BTNFACE)) ;
    winc.lpszMenuName   = null;
    winc.lpszClassName  = cast(wchar*)(ClassName) ;
    super(name) ;
  }
  
  LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch (msg) {
    case WM_DESTROY:
      DeleteObject(hfont);
      break ;
    case WM_CREATE:
      hfont = CreateFont(
			 12 , 0 , 0 , 0 , FW_REGULAR , FALSE , FALSE , FALSE ,
			 SHIFTJIS_CHARSET , OUT_DEFAULT_PRECIS ,
			 CLIP_DEFAULT_PRECIS , DEFAULT_QUALITY , 
			 FIXED_PITCH, null
			 );

      spinWidth = new Spin("spinWidth", "spinWidth") ;
      spinWidth.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      spinWidth.setPosition(70, 16,80,20) ;
      spinWidth.setTextFormat("%.0f") ;
      spinWidth.setInfo( 640, 128, 4096, 1 ) ;
      addObject(spinWidth, cast(HMENU)(201), false, false) ;
      spinWidth.setTextFont(hfont) ;

      spinHeight = new Spin("spinHeight", "spinHeight") ;
      spinHeight.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      spinHeight.setPosition(70, 36,80,20) ;
      spinHeight.setTextFormat("%.0f") ;
      spinHeight.setInfo( 480, 128, 4096, 1 ) ;
      addObject(spinHeight, cast(HMENU)(201), false, false) ;
      spinHeight.setTextFont(hfont) ;
      
      buttonOK= new PushButton("OK") ;
      buttonOK.addStyle(WS_TABSTOP) ;
      buttonOK.setPosition(winW-190,winH-40,80,20) ;
      addObject( buttonOK, cast(HMENU)(CMD.OK) ) ;
      buttonOK.setFont(hfont) ;

      buttonCAN= new PushButton("Cancel") ;
      buttonCAN.addStyle(WS_TABSTOP) ;
      buttonCAN.setPosition(winW-90,winH-40,80,20) ;
      addObject( buttonCAN, cast(HMENU)(CMD.CANCEL) ) ;
      buttonCAN.setFont(hfont) ;
      
      state=0 ;
      break ;
      
    case WM_PAINT:
      PAINTSTRUCT ps;
      HDC         hdc;
      wchar[] labelW = (toUTF16(cast(const char[])("Width" ~ "\0"))).dup ;
      wchar[] labelH = (toUTF16(cast(const char[])("Height"~ "\0"))).dup ;

      hdc = BeginPaint(hwnd, &ps);
      SetBkMode(hdc,TRANSPARENT) ;
      SelectObject(hdc , hfont);
      TextOut(hdc , 32, 19 , cast(wchar*)(labelW), labelW.length);
      TextOut(hdc , 32, 39 , cast(wchar*)(labelH), labelH.length);
      EndPaint(hwnd, &ps);
      break ;
      
    case WM_SIZE:
      break ;
      
    case WM_CLOSE:
      setResult(0) ;
      DestroyWindow(hwnd);
      break ;
      
    case WM_COMMAND:
      state=LOWORD(wp) ;
      switch(state){
      case CMD.CANCEL:
	setResult(0) ;
	DestroyWindow(hwnd);
	break ;
      case CMD.OK:
	setResult(1) ;
	width  = cast(int)(spinWidth.getValue() ) ;
	height = cast(int)(spinHeight.getValue()) ;
	DestroyWindow(hwnd);
	break ;
      default : break ;
      }
      break ;
      
    default :
      return( DefWindowProc(hwnd , msg , wp , lp) );
    }
    return(0);
  }

  int getWidth(){
    return(width) ;
  }
  int getHeight(){
    return(height) ;
  }
}
  
